=== examples/xbr/Makefile ===
connect:
	python test_connect.py --gateway http://localhost:1545

typed:
	python test_typed.py --gateway http://localhost:1545

transfer:
	python test_transfer_tokens.py --gateway http://localhost:1545

register:
	python test_register.py --gateway http://localhost:1545

market:
	python test_market.py --gateway http://localhost:1545

domain:
	python test_domain.py --gateway http://localhost:1545

payment_channel:
	python test_payment_channel.py --gateway http://localhost:1545

sbc_connect:
	python test_sbc_connect.py --gateway http://localhost:1545 --adr "0x90f8bf6a479f320ead074411a4b0e7944ea8c9c1"
	python test_sbc_connect.py --gateway http://localhost:1545 --adr "0xFFcf8FDEE72ac11b5c542428B35EEF5769C409f0"
