=== examples/twisted/websocket/echo_variants/Makefile ===
client:
	PYTHONPATH=../../../../autobahn python client.py ws://127.0.0.1:9000
