=== examples/twisted/websocket/wrapping/Makefile ===
test_server:
	PYTHONPATH=../../../../autobahn python server.py

test_client:
	PYTHONPATH=../../../../autobahn python client.py
