=== debian/changelog ===
python-autobahn (24.4.2+dfsg1-2) unstable; urgency=medium

  * Uploading to unstable (Closes: #1115802).
  * Add patch-upstream-pytest.ini.patch.
  * Add make-test-function-async.patch.
  * Blacklist test_websocket_custom_loop.

 -- Thomas Goirand <zigo@debian.org>  Fri, 26 Sep 2025 11:18:49 +0200

python-autobahn (24.4.2+dfsg1-1) experimental; urgency=medium

  * New upstream release.

 -- Thomas Goirand <zigo@debian.org>  Wed, 27 Aug 2025 15:16:35 +0200
