=== debian/control ===
Source: python-autobahn
Section: python
Priority: optional
Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
Uploaders:
 Thomas Goirand <zigo@debian.org>,
Build-Depends:
 debhelper-compat (= 10),
 dh-python,
 openstack-pkg-tools,
 python3-all,
 python3-setuptools,
 python3-sphinx,
 python3-sphinx-rtd-theme,
Build-Depends-Indep:
 python3-attr,
 python3-base58,
 python3-cbor,
 python3-cffi,
 python3-cryptography,
 python3-ecdsa,
 python3-flatbuffers,
 python3-enchant,
 python3-hyperlink,
 python3-lz4,
 python3-mnemonic,
 python3-msgpack,
 python3-nacl,
 python3-openssl,
 python3-passlib,
 python3-pyqrcode,
 python3-pytest,
 python3-pytest-asyncio,
 python3-service-identity,
 python3-snappy,
 python3-trie,
 python3-twisted,
 python3-txaio,
 python3-u-msgpack,
 python3-ubjson,
 python3-ujson,
 python3-wsaccel,
 python3-zope.interface,
Standards-Version: 4.1.1
Vcs-Browser: https://salsa.debian.org/openstack-team/python/python-autobahn
Vcs-Git: https://salsa.debian.org/openstack-team/python/python-autobahn.git
Homepage: http://autobahn.ws/python

Package: python3-autobahn
Architecture: all
Depends:
 python3-attr,
 python3-base58,
 python3-cbor,
 python3-cffi,
 python3-cryptography,
 python3-ecdsa,
 python3-flatbuffers,
 python3-hyperlink,
 python3-lz4,
 python3-mnemonic,
 python3-msgpack,
 python3-nacl,
 python3-openssl,
 python3-passlib,
 python3-pyqrcode,
 python3-service-identity,
 python3-snappy,
 python3-trie,
 python3-twisted,
 python3-txaio,
 python3-u-msgpack,
 python3-ubjson,
 python3-ujson,
 python3-wsaccel,
 python3-zope.interface,
 ${misc:Depends},
 ${python3:Depends},
Description: WebSocket client and server library, WAMP framework - Python 3.x
 Autobahn|Python is a networking library that is part of the Autobahn project
 and provides implementations of:
  * The WebSocket Protocol
  * The Web Application Messaging Protocol (WAMP)
 for Twisted and asyncio, on Python 2 & 3 and for writing servers and clients.
 .
 WebSocket allows bidirectional real-time messaging on the Web and WAMP adds
 asynchronous Remote Procedure Calls and Publish & Subscribe on top of
 WebSocket.
 .
 This package contains the Python 3.x module.
