=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_GIT := https://github.com/crossbario/autobahn-python
include /usr/share/openstack-pkg-tools/pkgos.make

# Needed for tests:
export PYUBJSON_NO_EXTENSION=1
export AUTOBAHN_USE_NVX=0
export AUTOBAHN_USE_UJSON=1
export AUTOBAHN_USE_CBOR2=0
export USE_ASYNCIO=1

%:
	dh $@ --buildsystem=pybuild --with python3

override_dh_auto_clean:
	rm -rf twisted/plugins/dropin.cache
	rm -rf build .stestr .pytest_cache *.egg-info
	find . -iname '*.pyc' -delete
	for i in $$(find . -type d -iname __pycache__) ; do rm -rf $$i ; done

override_dh_auto_build:
	echo "Do nothing..."

override_dh_auto_install:
	pkgos-dh_auto_install --no-py2 --in-tmp

override_dh_auto_test:
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	set -e ; set -x ; for i in $(PYTHON3S) ; do \
		rm -rf build ; \
		PYTHONPATH=. python$$i -m pytest -Wignore -v \
			--ignore=./autobahn/twisted \
			--ignore=./autobahn/wamp \
			--ignore=./autobahn/websocket \
			--ignore=./autobahn/xbr \
			autobahn \
			-k 'not test_wamp_server and not test_websocket_custom_loop' \
			--asyncio-mode=auto ; \
	done
endif

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3
