=== debian/tests/control ===
Tests: unittests
Depends:
 @builddeps@,
Restrictions: allow-stderr needs-root
