=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg\d//" \
https://github.com/tavendo/AutobahnPython/tags .*/v(\d[\d\.]+)\.tar\.gz
